// ----------------------------------------------------------------------------
//
// rt_arg.h
// RT++ argument threads (fully typed)
//
// $Id: rt_arg.h,v 1.14 1996/02/28 15:51:55 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------
#ifndef RT_ARG_H
#define RT_ARG_H

// ----------------------------------------------------------------------------
//
// thread with zero arguments
//
// ----------------------------------------------------------------------------
template <class R>
class ArgumentThread0: public ResultThread<R>
{
  protected:
  R (*f)(void);
  void user(void); 
  public:
  void scan(void);
  void zero(void);
  void init(R (*_f)(void));
  ArgumentThread0(R (*_f)(void));
};

// ----------------------------------------------------------------------------
//
// thread with one argument
//
// ----------------------------------------------------------------------------
template <class R, class A1>
class ArgumentThread1: public ResultThread<R>
{
  protected:
  R (*f)(A1);
  A1 a1;
  void user(void);
  public:
  void scan(void);
  void zero(void);
  void init(R (*_f)(A1), A1 _a1);
  ArgumentThread1(R (*_f)(A1), A1 _a1);
};

// ----------------------------------------------------------------------------
//
// thread with two arguments
//
// ----------------------------------------------------------------------------
template <class R, class A1, class A2>
class ArgumentThread2: public ResultThread<R>
{
  protected:
  R (*f)(A1, A2);
  A1 a1;
  A2 a2;
  void user(void);
  public:
  void scan(void);
  void zero(void);
  void init(R (*_f)(A1, A2), A1 _a1, A2 _a2);
  ArgumentThread2(R (*_f)(A1, A2), A1 _a1, A2 _a2);
};

// ----------------------------------------------------------------------------
//
// thread with three arguments
//
// ----------------------------------------------------------------------------
template <class R, class A1, class A2, class A3>
class ArgumentThread3: public ResultThread<R>
{
  protected:
  R (*f)(A1, A2, A3);
  A1 a1;
  A2 a2;
  A3 a3;
  void user(void);
  public:
  void scan(void);
  void zero(void);
  void init(R (*_f)(A1, A2, A3), A1 _a1, A2 _a2, A3 _a3);
  ArgumentThread3(R (*_f)(A1, A2, A3), A1 _a1, A2 _a2, A3 _a3);
};

// ----------------------------------------------------------------------------
//
// thread with four arguments
//
// ----------------------------------------------------------------------------
template <class R, class A1, class A2, class A3, class A4>
class ArgumentThread4: public ResultThread<R>
{
  protected:
  R (*f)(A1, A2, A3, A4);
  A1 a1;
  A2 a2;
  A3 a3;
  A4 a4;
  void user(void);
  public:
  void scan(void);
  void zero(void);
  void init(R (*_f)(A1, A2, A3, A4), A1 _a1, A2 _a2, A3 _a3, A4 _a4);
  ArgumentThread4(R (*_f)(A1, A2, A3, A4), A1 _a1, A2 _a2, A3 _a3, A4 _a4);
};

#endif
// ----------------------------------------------------------------------------
// end of rt_arg.h
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
