// ----------------------------------------------------------------------------
//
// rt_mutex.h
// RT++ mutual exclusion objects
//
// $Id: rt_mutex.h,v 1.9 1996/03/13 12:25:32 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------
#ifndef RT_MUTEX_H
#define RT_MUTEX_H

// ----------------------------------------------------------------------------
//
// mutex object; can be locked by one process at a time only.
//
// ----------------------------------------------------------------------------
class Mutex 
{
#ifdef RT_PARISC
  volatile int cache[7]; // mutex must be 16 bytes aligned
  volatile int *mutex;   // and no data must be in same cache line as mutex
#else
  volatile int mutex;    // mutex object
#endif
  public:
  void init(void);   // initialize mutex
  Mutex(void);       // create mutex
  void lock(void);   // lock mutex
  void unlock(void); // unlock mutex
  int test(void);    // try to lock mutex and return(0) if not successful
};

#endif
// ----------------------------------------------------------------------------
// end of rt_mutex.h
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
