// ----------------------------------------------------------------------------
//
// arrays.cc
// test of RT++ arrays and garbage collection
//
// $Id: arrays.cc,v 1.4 1996/04/03 08:33:14 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Ref(Array<int>);

// ----------------------------------------------------------------------------
//
// create iteratively array of arrays
// keep last array for consistency check after gc
//
// ----------------------------------------------------------------------------
int arrays(int, char *[])
{
  Array< Array<int> > c;
  for (int k = 0; k < 30; k++)
    {
      int N = rand()%500+1;
      Array< Array<int> > b(N);
      for (int i=0; i < N; i++)
        {
	  int M = rand()%100+1;
	  Array<int> a(M);
	  for (int j=0; j < M; j++)            
	    {
	      a[j] = j;
	    }
          b[i] = a;
        }
      if (!Null(c)) 
	{
	  int N = Length(c);
	  for (int i=0; i < N; i++)
	    {
	      int M = Length(c[i]);
	      for (int j=0; j < M; j++) {
		if (c[i][j] != j) rt_abort("gc error\n");
	      }
	    }
	}
      c = b;
    }
  return(0);
}

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(arrays, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of arrays.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
