// ----------------------------------------------------------------------------
//
// threads.cc
// test of RT++ threads and garbage collection
//
// $Id: threads.cc,v 1.3 1996/04/03 08:33:24 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Ref(Thread<int>);
ThreadRes(int);
ThreadArg1(A, int, int); 

// ----------------------------------------------------------------------------
//
// create list and check for consistency
//
// ----------------------------------------------------------------------------
int list(int n)
{
  List<int> l;
  int i;
  for (i = 0; i < n; i++)
    { 
      for (int j = 0; j < 1000; j++) {}
      l.cons(i, l);
    }
  while (!Null(l))
    {
      i--;
      if (Head(l) != i) rt_abort("elem error");
      l.tail();
    }
  if (i!=0) rt_abort("count error");
  return(1);
}

// ----------------------------------------------------------------------------
//
// start list of threads and collect results
//
// ----------------------------------------------------------------------------
int threads(int, char *[])
{
  cout << "Start\n";
  List< Thread<int> > l;
  for (int i = 0; i < 200; i++)
    {
      Thread1<int, int> t(list, rand()%8000);
      l.cons(t, l);
    }
  int r = 0;
  while (!Null(l))
    {
      r += Wait(Head(l));
      l.tail();
    }
  cout << "Result " << r << "\n";
  return(0);
}

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(threads, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of threads.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
